diff -Naur src.pgsql/backend/nodes/tidbitmap.c src.bitmap/backend/nodes/tidbitmap.c
--- src.pgsql/backend/nodes/tidbitmap.c	2006-09-16 17:51:45.000000000 -0700
+++ src.bitmap/backend/nodes/tidbitmap.c	2006-09-17 00:09:28.000000000 -0700
@@ -36,59 +36,13 @@
 #include "storage/bufpage.h"
 #include "utils/hsearch.h"
 
-/*
- * The maximum number of tuples per page is not large (typically 256 with
- * 8K pages, or 1024 with 32K pages).  So there's not much point in making
- * the per-page bitmaps variable size.	We just legislate that the size
- * is this:
- */
-#define MAX_TUPLES_PER_PAGE  MaxHeapTuplesPerPage
-
-/*
- * When we have to switch over to lossy storage, we use a data structure
- * with one bit per page, where all pages having the same number DIV
- * PAGES_PER_CHUNK are aggregated into one chunk.  When a chunk is present
- * and has the bit set for a given page, there must not be a per-page entry
- * for that page in the page table.
- *
- * We actually store both exact pages and lossy chunks in the same hash
- * table, using identical data structures.	(This is because dynahash.c's
- * memory management doesn't allow space to be transferred easily from one
- * hashtable to another.)  Therefore it's best if PAGES_PER_CHUNK is the
- * same as MAX_TUPLES_PER_PAGE, or at least not too different.	But we
- * also want PAGES_PER_CHUNK to be a power of 2 to avoid expensive integer
- * remainder operations.  So, define it like this:
- */
-#define PAGES_PER_CHUNK  (BLCKSZ / 32)
-
-/* The bitmap unit size can be adjusted by changing these declarations: */
-#define BITS_PER_BITMAPWORD 32
-typedef uint32 bitmapword;		/* must be an unsigned type */
-
-#define WORDNUM(x)	((x) / BITS_PER_BITMAPWORD)
-#define BITNUM(x)	((x) % BITS_PER_BITMAPWORD)
-
-/* number of active words for an exact page: */
-#define WORDS_PER_PAGE	((MAX_TUPLES_PER_PAGE - 1) / BITS_PER_BITMAPWORD + 1)
-/* number of active words for a lossy chunk: */
-#define WORDS_PER_CHUNK  ((PAGES_PER_CHUNK - 1) / BITS_PER_BITMAPWORD + 1)
-
-/*
- * The hashtable entries are represented by this data structure.  For
- * an exact page, blockno is the page number and bit k of the bitmap
- * represents tuple offset k+1.  For a lossy chunk, blockno is the first
- * page in the chunk (this must be a multiple of PAGES_PER_CHUNK) and
- * bit k represents page blockno+k.  Note that it is not possible to
- * have exact storage for the first page of a chunk if we are using
- * lossy storage for any page in the chunk's range, since the same
- * hashtable entry has to serve both purposes.
- */
-typedef struct PagetableEntry
-{
-	BlockNumber blockno;		/* page number (hashtable key) */
-	bool		ischunk;		/* T = lossy storage, F = exact */
-	bitmapword	words[Max(WORDS_PER_PAGE, WORDS_PER_CHUNK)];
-} PagetableEntry;
+#define WORDNUM(x)	((x) / TBM_BITS_PER_BITMAPWORD)
+#define BITNUM(x)	((x) % TBM_BITS_PER_BITMAPWORD)
+
+static bool
+tbm_iterate_page(PagetableEntry* page, TBMIterateResult* output);
+static bool
+tbm_iterate_hash(HashBitmap *tbm, TBMIterateResult *output );
 
 /*
  * dynahash.c is optimized for relatively large, long-lived hash tables.
@@ -103,15 +57,15 @@
  */
 typedef enum
 {
-	TBM_EMPTY,					/* no hashtable, nentries == 0 */
-	TBM_ONE_PAGE,				/* entry1 contains the single entry */
-	TBM_HASH					/* pagetable is valid, entry1 is not */
+	HASHBM_EMPTY,					/* no hashtable, nentries == 0 */
+	HASHBM_ONE_PAGE,				/* entry1 contains the single entry */
+	HASHBM_HASH					/* pagetable is valid, entry1 is not */
 } TBMStatus;
 
 /*
- * Here is the representation for a whole TIDBitMap:
+ * Here is the representation for a whole HashBitmap.
  */
-struct TIDBitmap
+struct HashBitmap
 {
 	NodeTag		type;			/* to make it a valid Node */
 	MemoryContext mcxt;			/* memory context containing me */
@@ -122,27 +76,26 @@
 	int			npages;			/* number of exact entries in pagetable */
 	int			nchunks;		/* number of lossy entries in pagetable */
 	bool		iterating;		/* tbm_begin_iterate called? */
-	PagetableEntry entry1;		/* used when status == TBM_ONE_PAGE */
+	PagetableEntry entry1;		/* used when status == HASHBM_ONE_PAGE */
 	/* the remaining fields are used while producing sorted output: */
 	PagetableEntry **spages;	/* sorted exact-page list, or NULL */
 	PagetableEntry **schunks;	/* sorted lossy-chunk list, or NULL */
 	int			spageptr;		/* next spages index */
 	int			schunkptr;		/* next schunks index */
 	int			schunkbit;		/* next bit to check in current schunk */
-	TBMIterateResult output;	/* MUST BE LAST (because variable-size) */
 };
 
 
 /* Local function prototypes */
-static void tbm_union_page(TIDBitmap *a, const PagetableEntry *bpage);
-static bool tbm_intersect_page(TIDBitmap *a, PagetableEntry *apage,
-				   const TIDBitmap *b);
-static const PagetableEntry *tbm_find_pageentry(const TIDBitmap *tbm,
+static void tbm_union_page(HashBitmap *a, const PagetableEntry *bpage);
+static bool tbm_intersect_page(HashBitmap *a, PagetableEntry *apage,
+				   const HashBitmap *b);
+static const PagetableEntry *tbm_find_pageentry(const HashBitmap *tbm,
 				   BlockNumber pageno);
-static PagetableEntry *tbm_get_pageentry(TIDBitmap *tbm, BlockNumber pageno);
-static bool tbm_page_is_lossy(const TIDBitmap *tbm, BlockNumber pageno);
-static void tbm_mark_page_lossy(TIDBitmap *tbm, BlockNumber pageno);
-static void tbm_lossify(TIDBitmap *tbm);
+static PagetableEntry *tbm_get_pageentry(HashBitmap *tbm, BlockNumber pageno);
+static bool tbm_page_is_lossy(const HashBitmap *tbm, BlockNumber pageno);
+static void tbm_mark_page_lossy(HashBitmap *tbm, BlockNumber pageno);
+static void tbm_lossify(HashBitmap *tbm);
 static int	tbm_comparator(const void *left, const void *right);
 
 
@@ -153,24 +106,22 @@
  * at the time of this call.  It will be limited to (approximately) maxbytes
  * total memory consumption.
  */
-TIDBitmap *
+HashBitmap *
 tbm_create(long maxbytes)
 {
-	TIDBitmap  *tbm;
+	HashBitmap  *tbm;
 	long		nbuckets;
 
 	/*
-	 * Create the TIDBitmap struct, with enough trailing space to serve the
-	 * needs of the TBMIterateResult sub-struct.
+	 * Create the HashBitmap struct.
 	 */
-	tbm = (TIDBitmap *) palloc(sizeof(TIDBitmap) +
-							   MAX_TUPLES_PER_PAGE * sizeof(OffsetNumber));
+	tbm = (HashBitmap *) palloc(sizeof(HashBitmap));
 	/* Zero all the fixed fields */
-	MemSetAligned(tbm, 0, sizeof(TIDBitmap));
+	MemSetAligned(tbm, 0, sizeof(HashBitmap));
 
-	tbm->type = T_TIDBitmap;	/* Set NodeTag */
+	tbm->type = T_HashBitmap;	/* Set NodeTag */
 	tbm->mcxt = CurrentMemoryContext;
-	tbm->status = TBM_EMPTY;
+	tbm->status = HASHBM_EMPTY;
 
 	/*
 	 * Estimate number of hashtable entries we can have within maxbytes. This
@@ -190,15 +141,29 @@
 }
 
 /*
+ * tbm_create_stream - create an empty stream bitmap.
+ */
+StreamBitmap*
+tbm_create_stream()
+{
+	StreamBitmap* streamBitmap =
+		(StreamBitmap*) palloc0(sizeof(StreamBitmap));
+	streamBitmap->type = T_StreamBitmap;
+	streamBitmap->nextBlockNo = InvalidBlockNumber;
+
+	return streamBitmap;
+}
+
+/*
  * Actually create the hashtable.  Since this is a moderately expensive
  * proposition, we don't do it until we have to.
  */
 static void
-tbm_create_pagetable(TIDBitmap *tbm)
+tbm_create_pagetable(HashBitmap *tbm)
 {
 	HASHCTL		hash_ctl;
 
-	Assert(tbm->status != TBM_HASH);
+	Assert(tbm->status != HASHBM_HASH);
 	Assert(tbm->pagetable == NULL);
 
 	/* Create the hashtable proper */
@@ -207,13 +172,13 @@
 	hash_ctl.entrysize = sizeof(PagetableEntry);
 	hash_ctl.hash = tag_hash;
 	hash_ctl.hcxt = tbm->mcxt;
-	tbm->pagetable = hash_create("TIDBitmap",
+	tbm->pagetable = hash_create("HashBitmap",
 								 128,	/* start small and extend */
 								 &hash_ctl,
 								 HASH_ELEM | HASH_FUNCTION | HASH_CONTEXT);
 
 	/* If entry1 is valid, push it into the hashtable */
-	if (tbm->status == TBM_ONE_PAGE)
+	if (tbm->status == HASHBM_ONE_PAGE)
 	{
 		PagetableEntry *page;
 		bool		found;
@@ -225,14 +190,14 @@
 		memcpy(page, &tbm->entry1, sizeof(PagetableEntry));
 	}
 
-	tbm->status = TBM_HASH;
+	tbm->status = HASHBM_HASH;
 }
 
 /*
- * tbm_free - free a TIDBitmap
+ * tbm_free - free a HashBitmap
  */
 void
-tbm_free(TIDBitmap *tbm)
+tbm_free(HashBitmap *tbm)
 {
 	if (tbm->pagetable)
 		hash_destroy(tbm->pagetable);
@@ -244,10 +209,132 @@
 }
 
 /*
- * tbm_add_tuples - add some tuple IDs to a TIDBitmap
+ * tbm_construct_stream_and - construct a result stream bitmap by
+ *							  ANDing a given list of stream bitmaps.
+ *
+ * If we didn't allocate space for the result stream bitmap, we
+ * will allocate the space here.
  */
 void
-tbm_add_tuples(TIDBitmap *tbm, const ItemPointer tids, int ntids)
+tbm_construct_stream_and(List *streamBitmaps, StreamBitmap** out_p)
+{
+	StreamBitmap	*out;
+	int				wordnum;
+	ListCell		*l;
+
+	if (*out_p == NULL)
+		*out_p = (StreamBitmap*)palloc0(sizeof(StreamBitmap));
+	else
+		MemSet(*out_p, 0, sizeof(StreamBitmap));
+
+	out = *out_p;
+	out->entry.blockno = InvalidBlockNumber;
+
+	foreach(l, streamBitmaps)
+	{
+		StreamBitmap	*streamBitmap = (StreamBitmap*) lfirst(l);
+
+		if (out->entry.blockno == InvalidBlockNumber)
+		{
+			memcpy(out, streamBitmap, sizeof(StreamBitmap));
+			continue;
+		}
+
+		out->entry.ischunk = streamBitmap->entry.ischunk;
+
+		for (wordnum = 0; wordnum < WORDS_PER_PAGE; wordnum++)
+		{
+			Assert(out->entry.blockno == streamBitmap->entry.blockno);
+
+			out->entry.words[wordnum] &= streamBitmap->entry.words[wordnum];
+		}
+	}
+}
+
+/*
+ * tbm_construct_stream_or - construct a result stream bitmap by
+ *							 ORing a given list of stream bitmaps.
+ *
+ * If we didn't allocate space for the result stream bitmap, we
+ * will allocate the space here.
+ */
+void
+tbm_construct_stream_or(List *streamBitmaps, StreamBitmap** out_p)
+{
+	StreamBitmap	*out;
+	int				wordnum;
+	ListCell		*l;
+
+	if (*out_p == NULL)
+		*out_p = (StreamBitmap*)palloc0(sizeof(StreamBitmap));
+	else
+		MemSet(*out_p, 0, sizeof(StreamBitmap));
+
+	out = *out_p;
+	out->entry.blockno = InvalidBlockNumber;
+
+	foreach(l, streamBitmaps)
+	{
+		StreamBitmap	*streamBitmap = (StreamBitmap*) lfirst(l);
+
+		if (out->entry.blockno == InvalidBlockNumber)
+		{
+			memcpy(out, streamBitmap, sizeof(StreamBitmap));
+			continue;
+		}
+
+		out->entry.ischunk = streamBitmap->entry.ischunk;
+
+		for (wordnum = 0; wordnum < WORDS_PER_PAGE; wordnum++)
+		{
+			Assert(out->entry.blockno == streamBitmap->entry.blockno);
+
+			out->entry.words[wordnum] |= streamBitmap->entry.words[wordnum];
+		}
+	}
+}
+
+/*
+ * tbm_hash_to_stream - construct a stream bitmap for a given block
+ *		from a given hash bitmap.
+ */
+StreamBitmap *
+tbm_hash_to_stream(HashBitmap* hashBitmap, BlockNumber blockno)
+{
+	StreamBitmap *streamBitmap;
+	const PagetableEntry* entry = tbm_find_pageentry(hashBitmap, blockno);
+
+	/* hashBitmap does not have a lossy chunk header, then return NULL. */
+	if (entry == NULL && !tbm_page_is_lossy(hashBitmap, blockno))
+		return NULL;
+
+	/* advance the hashBitmap by one*/
+	if (!hashBitmap->iterating)
+		tbm_begin_iterate(hashBitmap);
+	tbm_iterate_hash(hashBitmap, NULL);
+
+	streamBitmap = tbm_create_stream();
+
+	if (entry != NULL)
+	{
+		memcpy(&(streamBitmap->entry), entry, sizeof(PagetableEntry));
+	} else
+	{
+		streamBitmap->entry.blockno = blockno;
+		streamBitmap->entry.ischunk = true;
+		memset(streamBitmap->entry.words, (~0),
+			   Max(WORDS_PER_PAGE, WORDS_PER_CHUNK)*sizeof(tbm_bitmapword));
+	}
+	streamBitmap->nextBlockNo = blockno+1;
+
+	return streamBitmap;
+}
+
+/*
+ * tbm_add_tuples - add some tuple IDs to a HashBitmap
+ */
+void
+tbm_add_tuples(HashBitmap *tbm, const ItemPointer tids, int ntids)
 {
 	int			i;
 
@@ -280,7 +367,7 @@
 			wordnum = WORDNUM(off - 1);
 			bitnum = BITNUM(off - 1);
 		}
-		page->words[wordnum] |= ((bitmapword) 1 << bitnum);
+		page->words[wordnum] |= ((tbm_bitmapword) 1 << bitnum);
 
 		if (tbm->nentries > tbm->maxentries)
 			tbm_lossify(tbm);
@@ -293,21 +380,21 @@
  * a is modified in-place, b is not changed
  */
 void
-tbm_union(TIDBitmap *a, const TIDBitmap *b)
+tbm_union(HashBitmap *a, const HashBitmap *b)
 {
 	Assert(!a->iterating);
 	/* Nothing to do if b is empty */
 	if (b->nentries == 0)
 		return;
 	/* Scan through chunks and pages in b, merge into a */
-	if (b->status == TBM_ONE_PAGE)
+	if (b->status == HASHBM_ONE_PAGE)
 		tbm_union_page(a, &b->entry1);
 	else
 	{
 		HASH_SEQ_STATUS status;
 		PagetableEntry *bpage;
 
-		Assert(b->status == TBM_HASH);
+		Assert(b->status == HASHBM_HASH);
 		hash_seq_init(&status, b->pagetable);
 		while ((bpage = (PagetableEntry *) hash_seq_search(&status)) != NULL)
 			tbm_union_page(a, bpage);
@@ -316,7 +403,7 @@
 
 /* Process one page of b during a union op */
 static void
-tbm_union_page(TIDBitmap *a, const PagetableEntry *bpage)
+tbm_union_page(HashBitmap *a, const PagetableEntry *bpage)
 {
 	PagetableEntry *apage;
 	int			wordnum;
@@ -326,13 +413,13 @@
 		/* Scan b's chunk, mark each indicated page lossy in a */
 		for (wordnum = 0; wordnum < WORDS_PER_PAGE; wordnum++)
 		{
-			bitmapword	w = bpage->words[wordnum];
+			tbm_bitmapword	w = bpage->words[wordnum];
 
 			if (w != 0)
 			{
 				BlockNumber pg;
 
-				pg = bpage->blockno + (wordnum * BITS_PER_BITMAPWORD);
+				pg = bpage->blockno + (wordnum * TBM_BITS_PER_BITMAPWORD);
 				while (w != 0)
 				{
 					if (w & 1)
@@ -354,7 +441,7 @@
 		if (apage->ischunk)
 		{
 			/* The page is a lossy chunk header, set bit for itself */
-			apage->words[0] |= ((bitmapword) 1 << 0);
+			apage->words[0] |= ((tbm_bitmapword) 1 << 0);
 		}
 		else
 		{
@@ -374,14 +461,14 @@
  * a is modified in-place, b is not changed
  */
 void
-tbm_intersect(TIDBitmap *a, const TIDBitmap *b)
+tbm_intersect(HashBitmap *a, const HashBitmap *b)
 {
 	Assert(!a->iterating);
 	/* Nothing to do if a is empty */
 	if (a->nentries == 0)
 		return;
 	/* Scan through chunks and pages in a, try to match to b */
-	if (a->status == TBM_ONE_PAGE)
+	if (a->status == HASHBM_ONE_PAGE)
 	{
 		if (tbm_intersect_page(a, &a->entry1, b))
 		{
@@ -390,7 +477,7 @@
 			a->npages--;
 			a->nentries--;
 			Assert(a->nentries == 0);
-			a->status = TBM_EMPTY;
+			a->status = HASHBM_EMPTY;
 		}
 	}
 	else
@@ -398,7 +485,7 @@
 		HASH_SEQ_STATUS status;
 		PagetableEntry *apage;
 
-		Assert(a->status == TBM_HASH);
+		Assert(a->status == HASHBM_HASH);
 		hash_seq_init(&status, a->pagetable);
 		while ((apage = (PagetableEntry *) hash_seq_search(&status)) != NULL)
 		{
@@ -425,7 +512,7 @@
  * Returns TRUE if apage is now empty and should be deleted from a
  */
 static bool
-tbm_intersect_page(TIDBitmap *a, PagetableEntry *apage, const TIDBitmap *b)
+tbm_intersect_page(HashBitmap *a, PagetableEntry *apage, const HashBitmap *b)
 {
 	const PagetableEntry *bpage;
 	int			wordnum;
@@ -437,15 +524,15 @@
 
 		for (wordnum = 0; wordnum < WORDS_PER_PAGE; wordnum++)
 		{
-			bitmapword	w = apage->words[wordnum];
+			tbm_bitmapword	w = apage->words[wordnum];
 
 			if (w != 0)
 			{
-				bitmapword	neww = w;
+				tbm_bitmapword	neww = w;
 				BlockNumber pg;
 				int			bitnum;
 
-				pg = apage->blockno + (wordnum * BITS_PER_BITMAPWORD);
+				pg = apage->blockno + (wordnum * TBM_BITS_PER_BITMAPWORD);
 				bitnum = 0;
 				while (w != 0)
 				{
@@ -455,7 +542,7 @@
 							tbm_find_pageentry(b, pg) == NULL)
 						{
 							/* Page is not in b at all, lose lossy bit */
-							neww &= ~((bitmapword) 1 << bitnum);
+							neww &= ~((tbm_bitmapword) 1 << bitnum);
 						}
 					}
 					pg++;
@@ -511,23 +598,23 @@
 }
 
 /*
- * tbm_is_empty - is a TIDBitmap completely empty?
+ * tbm_is_empty - is a HashBitmap completely empty?
  */
 bool
-tbm_is_empty(const TIDBitmap *tbm)
+tbm_is_empty(const HashBitmap *tbm)
 {
 	return (tbm->nentries == 0);
 }
 
 /*
- * tbm_begin_iterate - prepare to iterate through a TIDBitmap
+ * tbm_begin_iterate - prepare to iterate through a HashBitmap
  *
  * NB: after this is called, it is no longer allowed to modify the contents
  * of the bitmap.  However, you can call this multiple times to scan the
  * contents repeatedly.
  */
 void
-tbm_begin_iterate(TIDBitmap *tbm)
+tbm_begin_iterate(HashBitmap *tbm)
 {
 	HASH_SEQ_STATUS status;
 	PagetableEntry *page;
@@ -546,7 +633,7 @@
 	/*
 	 * Nothing else to do if no entries, nor if we don't have a hashtable.
 	 */
-	if (tbm->nentries == 0 || tbm->status != TBM_HASH)
+	if (tbm->nentries == 0 || tbm->status != HASHBM_HASH)
 		return;
 
 	/*
@@ -579,20 +666,90 @@
 }
 
 /*
- * tbm_iterate - scan through next page of a TIDBitmap
+ * tbm_iterate - scan through next page of a HashBitmap or a StreamBitmap.
+ */
+bool
+tbm_iterate(Node *tbm, TBMIterateResult* output)
+{
+	Assert(IsA(tbm, HashBitmap) || IsA(tbm, StreamBitmap));
+
+	switch(tbm->type)
+	{
+		case T_HashBitmap:
+		{
+			HashBitmap* hashBitmap = (HashBitmap*)tbm;
+			if (!hashBitmap->iterating)
+				tbm_begin_iterate(hashBitmap);
+
+			return tbm_iterate_hash(hashBitmap, output);
+		}
+		case T_StreamBitmap:
+		{
+			StreamBitmap* streamBitmap = (StreamBitmap*)tbm;
+			bool status = tbm_iterate_page(&(streamBitmap->entry), output);
+
+			/* if this stream bitmap is lossy, then reset output->ntuples */
+			if (streamBitmap->entry.ischunk)
+				output->ntuples = -1;
+			return status;
+		}
+
+		default:
+			elog(ERROR, "unrecoganized node type");
+	}
+
+	return false;
+}
+
+/*
+ * tbm_iterate_page - get a TBMIterateResult from a given PagetableEntry.
+ */
+static bool
+tbm_iterate_page(PagetableEntry* page, TBMIterateResult* output)
+{
+	int			ntuples;
+	int			wordnum;
+
+	/* scan bitmap to extract individual offset numbers */
+	ntuples = 0;
+	for (wordnum = 0; wordnum < WORDS_PER_PAGE; wordnum++)
+	{
+		tbm_bitmapword	w = page->words[wordnum];
+
+		if (w != 0)
+		{
+			int			off = wordnum * TBM_BITS_PER_BITMAPWORD + 1;
+
+			while (w != 0)
+			{
+				if (w & 1)
+					output->offsets[ntuples++] = (OffsetNumber) off;
+				off++;
+				w >>= 1;
+			}
+		}
+	}
+	output->blockno = page->blockno;
+	output->ntuples = ntuples;
+
+	return true;
+}
+
+/*
+ * tbm_iterate_hash - scan through next page of a HashBitmap
  *
- * Returns a TBMIterateResult representing one page, or NULL if there are
+ * Gets a TBMIterateResult representing one page, or NULL if there are
  * no more pages to scan.  Pages are guaranteed to be delivered in numerical
  * order.  If result->ntuples < 0, then the bitmap is "lossy" and failed to
  * remember the exact tuples to look at on this page --- the caller must
  * examine all tuples on the page and check if they meet the intended
  * condition.
+ *
+ * If 'output' is NULL, simple advance the HashBitmap by one.
  */
-TBMIterateResult *
-tbm_iterate(TIDBitmap *tbm)
+static bool
+tbm_iterate_hash(HashBitmap *tbm, TBMIterateResult *output)
 {
-	TBMIterateResult *output = &(tbm->output);
-
 	Assert(tbm->iterating);
 
 	/*
@@ -609,7 +766,7 @@
 			int			wordnum = WORDNUM(schunkbit);
 			int			bitnum = BITNUM(schunkbit);
 
-			if ((chunk->words[wordnum] & ((bitmapword) 1 << bitnum)) != 0)
+			if ((chunk->words[wordnum] & ((tbm_bitmapword) 1 << bitnum)) != 0)
 				break;
 			schunkbit++;
 		}
@@ -637,52 +794,36 @@
 			chunk_blockno < tbm->spages[tbm->spageptr]->blockno)
 		{
 			/* Return a lossy page indicator from the chunk */
-			output->blockno = chunk_blockno;
-			output->ntuples = -1;
+			if (output != NULL)
+			{
+				output->blockno = chunk_blockno;
+				output->ntuples = -1;
+			}
+
 			tbm->schunkbit++;
-			return output;
+			return true;
 		}
 	}
 
 	if (tbm->spageptr < tbm->npages)
 	{
 		PagetableEntry *page;
-		int			ntuples;
-		int			wordnum;
 
 		/* In ONE_PAGE state, we don't allocate an spages[] array */
-		if (tbm->status == TBM_ONE_PAGE)
+		if (tbm->status == HASHBM_ONE_PAGE)
 			page = &tbm->entry1;
 		else
 			page = tbm->spages[tbm->spageptr];
 
-		/* scan bitmap to extract individual offset numbers */
-		ntuples = 0;
-		for (wordnum = 0; wordnum < WORDS_PER_PAGE; wordnum++)
-		{
-			bitmapword	w = page->words[wordnum];
-
-			if (w != 0)
-			{
-				int			off = wordnum * BITS_PER_BITMAPWORD + 1;
+		if (output != NULL)
+			tbm_iterate_page(page, output);
 
-				while (w != 0)
-				{
-					if (w & 1)
-						output->offsets[ntuples++] = (OffsetNumber) off;
-					off++;
-					w >>= 1;
-				}
-			}
-		}
-		output->blockno = page->blockno;
-		output->ntuples = ntuples;
 		tbm->spageptr++;
-		return output;
+		return true;
 	}
 
 	/* Nothing more in the bitmap */
-	return NULL;
+	return false;
 }
 
 /*
@@ -691,14 +832,14 @@
  * Returns NULL if there is no non-lossy entry for the pageno.
  */
 static const PagetableEntry *
-tbm_find_pageentry(const TIDBitmap *tbm, BlockNumber pageno)
+tbm_find_pageentry(const HashBitmap *tbm, BlockNumber pageno)
 {
 	const PagetableEntry *page;
 
 	if (tbm->nentries == 0)		/* in case pagetable doesn't exist */
 		return NULL;
 
-	if (tbm->status == TBM_ONE_PAGE)
+	if (tbm->status == HASHBM_ONE_PAGE)
 	{
 		page = &tbm->entry1;
 		if (page->blockno != pageno)
@@ -726,21 +867,21 @@
  * up to the caller to call tbm_lossify() at the next safe point if so.
  */
 static PagetableEntry *
-tbm_get_pageentry(TIDBitmap *tbm, BlockNumber pageno)
+tbm_get_pageentry(HashBitmap *tbm, BlockNumber pageno)
 {
 	PagetableEntry *page;
 	bool		found;
 
-	if (tbm->status == TBM_EMPTY)
+	if (tbm->status == HASHBM_EMPTY)
 	{
 		/* Use the fixed slot */
 		page = &tbm->entry1;
 		found = false;
-		tbm->status = TBM_ONE_PAGE;
+		tbm->status = HASHBM_ONE_PAGE;
 	}
 	else
 	{
-		if (tbm->status == TBM_ONE_PAGE)
+		if (tbm->status == HASHBM_ONE_PAGE)
 		{
 			page = &tbm->entry1;
 			if (page->blockno == pageno)
@@ -772,7 +913,7 @@
  * tbm_page_is_lossy - is the page marked as lossily stored?
  */
 static bool
-tbm_page_is_lossy(const TIDBitmap *tbm, BlockNumber pageno)
+tbm_page_is_lossy(const HashBitmap *tbm, BlockNumber pageno)
 {
 	PagetableEntry *page;
 	BlockNumber chunk_pageno;
@@ -781,7 +922,7 @@
 	/* we can skip the lookup if there are no lossy chunks */
 	if (tbm->nchunks == 0)
 		return false;
-	Assert(tbm->status == TBM_HASH);
+	Assert(tbm->status == HASHBM_HASH);
 
 	bitno = pageno % PAGES_PER_CHUNK;
 	chunk_pageno = pageno - bitno;
@@ -793,7 +934,7 @@
 		int			wordnum = WORDNUM(bitno);
 		int			bitnum = BITNUM(bitno);
 
-		if ((page->words[wordnum] & ((bitmapword) 1 << bitnum)) != 0)
+		if ((page->words[wordnum] & ((tbm_bitmapword) 1 << bitnum)) != 0)
 			return true;
 	}
 	return false;
@@ -806,7 +947,7 @@
  * up to the caller to call tbm_lossify() at the next safe point if so.
  */
 static void
-tbm_mark_page_lossy(TIDBitmap *tbm, BlockNumber pageno)
+tbm_mark_page_lossy(HashBitmap *tbm, BlockNumber pageno)
 {
 	PagetableEntry *page;
 	bool		found;
@@ -816,7 +957,7 @@
 	int			bitnum;
 
 	/* We force the bitmap into hashtable mode whenever it's lossy */
-	if (tbm->status != TBM_HASH)
+	if (tbm->status != HASHBM_HASH)
 		tbm_create_pagetable(tbm);
 
 	bitno = pageno % PAGES_PER_CHUNK;
@@ -860,7 +1001,7 @@
 		page->blockno = chunk_pageno;
 		page->ischunk = true;
 		/* we assume it had some tuple bit(s) set, so mark it lossy */
-		page->words[0] = ((bitmapword) 1 << 0);
+		page->words[0] = ((tbm_bitmapword) 1 << 0);
 		/* adjust counts */
 		tbm->nchunks++;
 		tbm->npages--;
@@ -869,14 +1010,14 @@
 	/* Now set the original target page's bit */
 	wordnum = WORDNUM(bitno);
 	bitnum = BITNUM(bitno);
-	page->words[wordnum] |= ((bitmapword) 1 << bitnum);
+	page->words[wordnum] |= ((tbm_bitmapword) 1 << bitnum);
 }
 
 /*
  * tbm_lossify - lose some information to get back under the memory limit
  */
 static void
-tbm_lossify(TIDBitmap *tbm)
+tbm_lossify(HashBitmap *tbm)
 {
 	HASH_SEQ_STATUS status;
 	PagetableEntry *page;
@@ -888,7 +1029,7 @@
 	 * to lossify more than the minimum number of pages during each call.
 	 */
 	Assert(!tbm->iterating);
-	Assert(tbm->status == TBM_HASH);
+	Assert(tbm->status == HASHBM_HASH);
 
 	hash_seq_init(&status, tbm->pagetable);
 	while ((page = (PagetableEntry *) hash_seq_search(&status)) != NULL)
diff -Naur src.pgsql/backend/utils/adt/selfuncs.c src.bitmap/backend/utils/adt/selfuncs.c
--- src.pgsql/backend/utils/adt/selfuncs.c	2006-09-16 17:51:39.000000000 -0700
+++ src.bitmap/backend/utils/adt/selfuncs.c	2006-09-17 00:09:25.000000000 -0700
@@ -4975,3 +4975,22 @@
 
 	PG_RETURN_VOID();
 }
+
+Datum
+bmcostestimate(PG_FUNCTION_ARGS)
+{
+	PlannerInfo *root = (PlannerInfo *) PG_GETARG_POINTER(0);
+	IndexOptInfo *index = (IndexOptInfo *) PG_GETARG_POINTER(1);
+	List	   *indexQuals = (List *) PG_GETARG_POINTER(2);
+	RelOptInfo *outer_rel = (RelOptInfo *) PG_GETARG_POINTER(3);
+	Cost	   *indexStartupCost = (Cost *) PG_GETARG_POINTER(4);
+	Cost	   *indexTotalCost = (Cost *) PG_GETARG_POINTER(5);
+	Selectivity *indexSelectivity = (Selectivity *) PG_GETARG_POINTER(6);
+	double	   *indexCorrelation = (double *) PG_GETARG_POINTER(7);
+
+	genericcostestimate(root, index, indexQuals, outer_rel, 0.0, 
+						indexStartupCost, indexTotalCost,
+						indexSelectivity, indexCorrelation);
+
+	PG_RETURN_VOID();
+}
